// *********************************************************
// ft_parInt_test4                           bach 05.09.2014
//
// mit UART - Interruptsteuerung (4 Zeichen)
//
// Testen Schieberegister Ausgang (4094)        getestet OK!
// *********************************************************
#include <ft_parInt.h>
#zero_ram

byte i;
byte st[4];                                   // uart buffer
byte rpos=0, wpos=0;                          // buffer pointer

// **********************************************************
byte read_uart (void) {
   if (rpos!=wpos) rpos=(rpos+1)&0x03;
return st[rpos];
}

// **********  wandelt Char in Hexzahl 0..9,a..f ************
byte c2h( void ) {
byte k;
  k=read_uart();
  if (bit_test(k,6)) k+=9;
  return (k&0x0f);
}

// **********************************************************
void main() {
   setup_adc( no_analogs);
   delay_ms (20);
   enable_interrupts(INT_EXT1_H2L);
   enable_interrupts(GLOBAL);

   printf ("\r\n Parallel Interface Test");
   printf ("\r\n Ausgangsregister CD4094 setzen");
   printf ("\r\n PIC18F14K22 Vers 4.j") ;
   delay_ms (2000);

while(true){
   output_high(Clk); delay_ms(10);
   output_low(Clk); delay_ms(100);
   if ((rpos^wpos)>1) {
       _out=(c2h()<<4)|c2h();
       printf ("\r\n Wert: %X ==> ", _out);
       for(i=7; i<8; i--) { if (bit_test(_out,i)) putc('1'); else putc('0'); }
       SR_out(_out);
       rpos=wpos;
       }
   }
}

// **********************************************************
#int_ext1
void uart_isr(void){ wpos=(wpos+1)&0x03; st[wpos]= getc(); }
